<?php
 

namespace addon\wechatexpress\model;

use app\model\BaseModel;
use think\facade\Db;
use app\model\order\OrderCommon;
class Express extends OrderCommon
{


//     ];
    //揽件成功
    const PEI_CREATE = 100001;
    //揽件失败
    const PEI_CANCEL = 100002;
    //分配业务员
    const PEI_STAFF = 100003;
    //更新运输轨迹
    const PEI_TRACE = 200001;
    //开始派送
    const PEI_PSISONG = 300002;
    //签收成功
    const PEI_ARRIVE = 300003;
    //签收失败
    const PEI_SIGN4 = 300004;
    //订单取消
    const SHOP_CANCEL = 400001;
    //订单滞留
    const PEI_ERROE = 400002;

    CONST PEI_LIST = [
        self::PEI_CREATE    => ['id' => self::PEI_CREATE, 'title' => '揽件成功'],
        self::PEI_CANCEL   => ['id' => self::PEI_CANCEL, 'title' => '揽件失败'],
        self::PEI_STAFF    => ['id' => self::PEI_STAFF, 'title' => '分配业务员'],
        self::PEI_TRACE    => ['id' => self::PEI_TRACE, 'title' => '更新运输轨迹'],
        self::PEI_PSISONG    => ['id' => self::PEI_PSISONG, 'title' => '开始派送'],
        self::PEI_ARRIVE   => ['id' => self::PEI_ARRIVE, 'title' => '签收成功'],
        self::PEI_SIGN4  => ['id' => self::PEI_SIGN4, 'title' => '签收失败'],
        self::SHOP_CANCEL  => ['id' => self::SHOP_CANCEL, 'title' => '订单取消'],
        self::PEI_ERROE     => ['id' => self::PEI_ERROE, 'title' => '订单滞留'],
    ];
  /**
     * 添加技师
     * @param $data
     * @return mixed
     */
    public function addExpress($data)
    {
        $express_info = model('store_express')->getInfo(
            [ [ 'biz_id', '=', $data[ 'biz_id' ] ], [ 'delivery_id', '=', $data[ 'delivery_id' ] ], ['is_delete' ,'=', 0]  ],
            'id'
        );
        if (!empty($express_info)) return $this->error('', '已添加');

        $data[ 'create_time' ] = time();
        model('store_express')->startTrans();
        try {
            $res = model('store_express')->add($data);
            model('store_express')->commit();
            return $this->success($res);
        } catch (\Exception $e) {
            model('store_express')->rollback();
            return $this->error('', $e->getMessage());
        }

    }


     /**
     * 修改
     * @param $data
     * @param $condition
     * @return array
     */
    public function editExpress($data, $condition, $id)
    {
        $express_info = model('store_express')->getInfo(
            [ [ 'id', '=', $id ], [ 'is_delete', '=', 0 ] ],
            'id'
        );
        if (empty($express_info)) return $this->error('', '技师不存在');
        $check_condition = array_column($condition, 2, 0);
        $site_id = isset($check_condition[ 'site_id' ]) ? $check_condition[ 'site_id' ] : '';
        if ($site_id === '') {
            return $this->error('', 'REQUEST_SITE_ID');
        }
        $data[ "modify_time" ] = time();

        model('store_express')->startTrans();
        try {
            model('store_express')->update($data, $condition);
            model('store_express')->commit();
            return $this->success($id);
        } catch (\Exception $e) {
            model('store_express')->rollback();
            return $this->error('', $e->getMessage());
        }
    }


    /**
     * 获取信息
     * @param int $satff_id
     * @return array
     */
    public function getExpressDetail($id, $site_id)
    {
        $field = '*';
        $express_info = model('store_express')->getInfo([ [ 'id', '=', $id ], [ 'site_id', '=', $site_id ] ], $field);
        if (!empty($express_info)) {
            return $this->success($express_info);
        }
        return $this->error();
    }


   

    /**
     * 获取详细信息
     * @param array $condition
     * @param string $field
     * @return array
     */
    public function getExpressInfo($condition = [], $field = '*')
    {
        $condition[] = [ 'is_delete', '=', 0 ];
        $res = model('store_express')->getInfo($condition, $field);
        return $this->success($res);
    }


    /**
     * 获取表
     * @param array $condition
     * @param string $field
     * @param string $order
     * @param null $limit
     * @return array
     */
    public function getExpressList($condition = [], $field = '*', $order = '', $limit = null)
    {
        $condition[] = [ 'is_delete', '=', 0 ];
        $list = model('store_express')->getList($condition, $field, $order, '', [], '', $limit);
        return $this->success($list);
    }
    

    /**
     * 获取分页列表
     * @param array $condition
     * @param int $page
     * @param int $page_size
     * @param string $order
     * @return array
     */
    public function getExpressPageList($condition = [], $page = 1, $page_size = PAGE_LIST_ROWS, $order = '')
    {
        $condition[] = [ 'is_delete', '=', 0 ];
        $field = '*';
       
        $list = model('store_express')->pageList($condition, $field, $order, $page, $page_size);
        return $this->success($list);
    }

    /**
     * 获取分页列表2
     * @param array $condition
     * @param int $page
     * @param int $page_size
     * @param string $order
     * @param string $field
     * @return array
     */
    public function getExpressPageLists($condition = [], $page = 1, $page_size = PAGE_LIST_ROWS, $order = '', $field = '*', $alias = 'a', $join = null)
    {
        $list = model('store_express')->pageList($condition, $field, $order, $page, $page_size, $alias, $join, '');
        return $this->success($list);
    }

    
     /**
     * 获取物流包裹列表
     * @param $condition
     * @param string $field
     * @return array
     */
    public function getExpressDeliveryPackageList($condition, $field = '*')
    {
        $list = model('express_delivery_package')->getList($condition, $field);
        return $this->success($list);
    }


    /**
     * 物流跟踪信息
     * @param $code
     * @param $company_id
     * @param $site_id
     * @param $mobile
     * @return array|mixed|void
     */
    public function trace($waybill_id, $company_id, $site_id, $openid = '')
    {
        $company_info_result = $this->getExpressInfo([ [ 'id', '=', $company_id ] ]);
        if (empty($company_info_result[ 'data' ]))
            return $this->success([ 'success' => false, 'reason' => '物流公司信息不完整!' ]);

        $weapp_model = new Weapp($site_id);
        $result = $weapp_model->getTrace([ 'waybill_id' => $waybill_id, 'delivery_id' => $company_info_result[ 'data' ][ 'delivery_id' ] ,'openid' => $openid ]);
        
        
        if (empty($result)) {
            $data = [ 'success' => false, 'reason' => '抱歉，没有启用的物流方式' ];
            return $this->success($data);
        }
        if ($result[ 'code' ] < 0) {
            $data = [ 'success' => false, 'reason' => '抱歉，暂无物流记录' ];
            return $this->success($data);
        }
        if ($result['data']['path_item_num'] == 0){
            $data = [ 'success' => false, 'reason' => '抱歉，暂无物流记录' ];
            return $this->success($data);
        }else{
            $status_name = '';
            $list = [];
            foreach($result['data']['path_item_list'] as $v){
                $list[] = [
                    'datetime'    => date('Ymd H:i:s',$v['action_time']),
                    'action_type' => self::PEI_LIST[$v['action_type']]['title'],
                    'remark'      => json_decode('"' . $v['action_msg'] . '"')
                ];
                $status_name = !empty($status_name) ? $status_name:self::PEI_LIST[$v['action_type']]['title'];
            }
            $data = [ 'success' => true, 'status_name' => $status_name, 'list' => $list];
            return $this->success($data);
        }
       
    }


     /**
     * 冻结
     * @param $staff_id
     * @return array
     */
    public function set_default($id)
    {
        $data = [
            'default' => 1
        ];
        model('store_express')->update([ 'default' => 0 ], [ [ 'id', '<>', $id ] ]);
        $res = model('store_express')->update($data, [ [ 'id', '=', $id ] ]);
        return $this->success($res);
    }

}