<?php
 

namespace addon\wechatexpress\shop\controller;

use addon\wechatexpress\model\Auth;
use addon\wechatexpress\model\Weapp;
use addon\wechatexpress\model\Express;
use app\shop\controller\BaseShop;
use addon\wechatexpress\model\Order as OrderDelivery;
use app\model\member\Member as MemberModel;

class Store extends BaseShop
{
    
    protected $replace = [];    //视图输出字符串内容替换    相当于配置文件中的'view_replace_str'

    public function __construct()
    {
        parent::__construct();
        $this->replace = [
         'EXPRESS_JS' => __ROOT__ . '/addon/wechatexpress/shop/view/public/js'
        ];
        $this->forthMenu();
    }
    
    public  function access()
    {
        $weapp = new Weapp($this->site_id);
        $res = $weapp->getConfig($this->site_id);
        $config_info = $res[ 'data' ][ 'value' ]; 
        if (request()->isJson()) {
            $data = input();
            $data['site_id'] = $this->site_id;
            return $weapp->setConfig($data);
        }
        $this->assign('config_info', $config_info);
        $account_data = $weapp->getDelivery();
        $this->assign('account_list', $account_data['list']);
        $this->assign('sd_list', $account_data['sd_list']);
        return $this->fetch("store/access");
    }

    /**
     *  配送员列表
     */
    public function lists()
    {
        $res = (new Auth())->shouquan($this->site_id);
        if($res['code'] != 0){
            echo "请配置授权码";exit;
            return $this->error('请配置授权码',href_url('wechatexpress://shop/store/access'));
        }
        $express_model = new Express();
        if (request()->isJson()) {
            $page = input('page', '1');
            $page_size = input('page_size', PAGE_LIST_ROWS);
            $condition = [
                [
                    'site_id', '=', $this->site_id,
                ],
                [
                    'is_delete', '=' , 0
                ]
            ];
            $search_text = input('search_text', '');
            if (!empty($search_text)) {
                $condition[] = [ 'delivery_name', 'like', '%' . $search_text . '%' ];
            }
            $express_lists = $express_model->getExpressPageLists($condition, $page, $page_size, 'create_time desc');
            return $express_lists;
        } else {
            return $this->fetch('store/lists');
        }
    }

    /**
     *  添加配送员
     */
    public function addExpress()
    {       
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
            $data = input();
            $data['site_id'] = $this->site_id;
            $bind_data = [
                'type' => 'bind',
                'biz_id' => $data['biz_id'],
                'delivery_id' =>  $data['delivery_id'],
                'password' =>  $data['password'],
                'remark_content' =>  $data['remark_content'],
            ];
            if(empty($bind_data['password'])) unset($bind_data['password']);
            if(empty($bind_data['remark_content'])) unset($bind_data['remark_content']);
            $res = $weapp->bindAccount($bind_data);
            if(!empty($res) && $res['code'] != 0) {
                return $res;
            }
            $account_data = $weapp->getDelivery();
            $account_list =  $account_data['list'];
            $account_list = array_column($account_list,null , 'delivery_id');
            $data['service_type'] = $account_list[$data['delivery_id']]['service_type'];
            $data['service_name'] = $account_list[$data['delivery_id']]['service_name'];
            $data['delivery_name'] = $account_list[$data['delivery_id']]['delivery_name'];
            $express_model = new Express();
            $res = $express_model->addExpress($data);
            return $res;
        }else{
            $weapp = new Weapp($this->site_id);
            $account_data = $weapp->getDelivery();
            $this->assign('account_list', $account_data['list']);
            return $this->fetch('store/addexpress');
        }
    }

    /**
     *  编辑配送员
     */
    public function editExpress()
    {
        $express_model = new Express();
        $express_id = input('express_id', 0);
        $this->assign('express_id', $express_id);
        $express_info = $express_model->getExpressInfo($express_id, $this->site_id);
        $this->assign('express_info', $express_info[ 'data' ]);
        $weapp = new Weapp($this->site_id);
        $account_data = $weapp->getDelivery();
        $this->assign('account_list', $account_data['list']);
        return $this->fetch('store/editexpress');
    }

    public function unBindAccount(){
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
            $express_model = new Express();
            $params = input();
            $express_id = $params['express_id'];
            $condition = [
                [
                    'site_id', '=', $this->site_id,
                ],
                [
                    'id', '=', $express_id,
                ]
            ];

            $express_info = $express_model->getExpressInfo($condition);
            $bind_data = [
                'type' => 'unbind',
                'biz_id' => $express_info[ 'data' ]['biz_id'],
                'delivery_id' =>  $express_info[ 'data' ]['delivery_id'],
                'password' =>  $express_info[ 'data' ]['password'],
                'remark_content' =>  $express_info[ 'data' ]['remark_content']
            ];
            if(empty($bind_data['password'])) unset($bind_data['password']);
            if(empty($bind_data['remark_content'])) unset($bind_data['remark_content']);
            $res = $weapp->bindAccount($bind_data);
            if(!empty($res) && $res['code'] != 0) {
                return $res;
            }else{
                $update_data['is_delete'] = 1;
                model('store_express')->update($update_data, $condition);
            }
            return  $res;
       }
    }

    public function updatePrinter(){
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
            $params = input();
            $member_id = $params['member_id'];
            $openid = $params['openid'];
            $type = $params['type'];
            if($type  == 'unbind'){
                $priter_data = [
                    'openid' => $openid,
                    'update_type'   => 'unbind'
                ];
                $res = $weapp->updatePrinter($priter_data);
            }else if($type  == 'bind'){
                $member = model('member')->getInfo([ [ 'member_id', '=', $member_id ] ], 'weapp_openid');
                if(empty($member['weapp_openid'])) {
                    return ['code'=>-1,'message'=>'当前账号未绑定小程序'];
                }else{
                    $priter_data = [
                        'openid' => $member['weapp_openid'],
                        'update_type'   => 'bind'
                    ];
                    $res = $weapp->updatePrinter($priter_data);
                }
            }
            return  $res;
        }
    }



    public function addOrder()
    {
        $weapp = new Weapp($this->site_id);
        $account_data = $weapp->getDelivery();
        $account_list =  $account_data['list'];
        $account_list = array_column($account_list,null ,'delivery_id');
        $delivery_ids = array_column($account_list,'delivery_id');
        $express_model = new Express();
        $condition = [
            [
                'site_id', '=', $this->site_id,
            ]
            
        ];
        $express_data = $express_model->getExpressPageList($condition,1,100);
        $express_lists = $express_data['data']['list'];
        $biz_ids = array_column($express_lists, 'biz_id');
        $ids = array_column($express_lists, 'delivery_id');
        $res = $weapp->getAllAccount();
        if(isset($res['data']['count']) && $res['data']['count'] > 0){
            $lists = $res['data']['list'];
            foreach($lists as $k=>$v){
                if(!in_array($v['biz_id'],$biz_ids) && !in_array($v['delivery_id'],$ids)){
                    $delevery_data = [
                        'biz_id' => $v['biz_id'],
                        'delivery_id' => $v['delivery_id'],
                        'delivery_name' => $account_list[$v['delivery_id']]['delivery_name'],
                        'service_type' => $account_list[$v['delivery_id']]['service_type'],
                        'service_name' => $account_list[$v['delivery_id']]['service_name'],
                        'site_id' => $this->site_id,
                    ];
                    $res = $express_model->addExpress($delevery_data);
                } 
            }
        }
       // echo __FILE__.__LINE__;exit;
        // $orderModel = new OrderDelivery();
        // $aa = $orderModel->payNotify(['order_id'=>11]);
        // $weapp = new Weapp($this->site_id);
        // $params = [
        //     'order_id' => '16',
        //     'site_id'  => $this->site_id,
        //     //'type'     => 1,  //商家发单  1商家发单 2 客户发单 
        //     'delivery_id' => 'TEST',
        //     'biz_id'   => 'test_biz_id',
        //     'waybill_id'   => '16_waybill_id',
        //     'action_time'   => '1701956032',
        //     'action_type'   => '100001',
        //     'action_msg'   => '揽件成功',
        // ];
        // $res = $weapp->testUpdateOrder($params);
        // print_r($res);exit;
        //return $res;
        // $str = '{"ToUserName":"gh_7582d1d9bf72","FromUserName":"o-XRQ5JRvBxhbnZQMjFwIp1gW98A","CreateTime":"1702134238","MsgType":"event","Event":"add_express_path","DeliveryID":"TEST","WayBillId":"16_waybill_id","Version":"1","Count":"1","Actions":{"ActionTime":"1701956032","ActionType":"100001","ActionMsg":"\\u63fd\\u4ef6\\u6210\\u529f","Lat":"0","Lng":"0"},"OrderId":"16"}';
        // $str = json_decode($str, true);
        // $res = $orderModel->expressNotify($str);
    }


    /**
     *  配送员列表
     */
    public function printerlists()
    {
        $res = (new Auth())->shouquan($this->site_id);
        if($res['code'] != 0){
            echo "请配置授权码";exit;
            return $this->error('请配置授权码',href_url('wechatexpress://shop/store/access'));
        }
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
           
            $res = $weapp->getPrinter();
            if($res['data']['count'] > 0){
                $openids = $res['data']['openid'];
                $condition = [];
                $condition[] = [ 'weapp_openid', 'in', $openids ];
                $members = model('member')->getList($condition, 'weapp_openid,nickname');
                $res['data']['list'] = array_values($members);
            }
            return $res;
        } else {
            return $this->fetch('store/printerlists');
        }
    }

    /**
     *  添加配送员
     */
    public function addPrinter()
    {       
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
            $data = input();
            $member = model('member')->getInfo([ [ 'member_id', '=', $data['member_id'] ] ], 'weapp_openid');
            if(empty($member['weapp_openid'])) {
                return ['code'=>-1,'message'=>'当前账号未绑定小程序'];
            }else{
                $priter_data = [
                    'openid' => $member['weapp_openid'],
                    'update_type'   => 'bind'
                ];
                $res = $weapp->updatePrinter($priter_data);
            }           
            return $res;
        }else{
            $weapp = new Weapp($this->site_id);
            $account_data = $weapp->getDelivery();
            $this->assign('account_list', $account_data['list']);
            return $this->fetch('store/addprinter');
        }
    }

    public function unBindPrinter(){
        $weapp = new Weapp($this->site_id);
        if (request()->isJson()) {
            $params = input();
            $openid = $params['openid'];
            $priter_data = [
                'openid' => $openid,
                'update_type'   => 'unbind'
            ];
            $res = $weapp->updatePrinter($priter_data);
            return  $res;
       }
    }

    /**
     * 获取会员列表
     */
    public function getMemberList()
    {
        $page_index = input('page', 1);
        $page_size = input('page_size', PAGE_LIST_ROWS);
        $member_search = input("member_search", '');
        $condition = [];
        $condition[] = [ 'mobile|email|username', 'like', '%' . $member_search . '%' ];
        $condition[] = [ 'site_id', '=', $this->site_id ];
        $member_model = new MemberModel();
        $list = $member_model->getMemberPageList($condition, $page_index, $page_size, '', 'member_id,headimg,nickname,point,weapp_openid');
        return $list;
    }

    
    /**
     * 会员详情
     */
    public function memberInfo()
    {
        if (request()->isJson()) {
            $member_id = input('member_id', '');
            $condition[] = [ 'site_id', '=', $this->site_id ];
            $condition[] = [ 'member_id', '=', $member_id ];
            $member_model = new MemberModel();
            $member_info_result = $member_model->getMemberInfo($condition);
            $member_info = $member_info_result[ "data" ];
            if (empty($member_info)) return $member_model->error([], "账号不存在！");
            return $member_info_result;
        }
    }


    /**
     * 会员详情
     */
    public function synsExpress()
    {
        if (request()->isJson()) {
            $weapp = new Weapp($this->site_id);
            $account_data = $weapp->getDelivery();
            $account_list =  $account_data['list'];
            $account_list = array_column($account_list,null ,'delivery_id');
            $delivery_ids = array_column($account_list,'delivery_id');
            $express_model = new Express();
            $condition = [
                [
                    'site_id', '=', $this->site_id,
                ]
                
            ];
            $express_data = $express_model->getExpressPageList($condition,1,100);
            $express_lists = $express_data['data']['list'];
            $biz_ids = array_column($express_lists, 'biz_id');
            $ids = array_column($express_lists, 'delivery_id');
            $res = $weapp->getAllAccount();
            if(isset($res['data']['count']) && $res['data']['count'] > 0){
                $lists = $res['data']['list'];
                foreach($lists as $k=>$v){
                    if(!in_array($v['biz_id'],$biz_ids) && !in_array($v['delivery_id'],$ids)){
                        $delevery_data = [
                            'biz_id' => $v['biz_id'],
                            'delivery_id' => $v['delivery_id'],
                            'delivery_name' => $account_list[$v['delivery_id']]['delivery_name'],
                            'service_type' => $account_list[$v['delivery_id']]['service_type'],
                            'service_name' => $account_list[$v['delivery_id']]['service_name'],
                            'site_id' => $this->site_id,
                        ];
                        $result =  $express_model->addExpress($delevery_data);
                    } 
                }
            }
            return $res;
        }
    }
}